#ifndef _CONTEXTMENU_ITEM_MATROSKA_H_
#define _CONTEXTMENU_ITEM_MATROSKA_H_

#include "../SDK/foobar2000.h"
#include "../foo_input_matroska/container_matroska.h"

// {A4D39E99-1120-4557-8D04-3DDF33215620}
static const GUID guid_contextmenu_item_matroska = 
{ 0xa4d39e99, 0x1120, 0x4557, { 0x8d, 0x4, 0x3d, 0xdf, 0x33, 0x21, 0x56, 0x20 } };

// {B4A87D2B-FA1B-450b-9AA4-BBD18CBF2393}
static const GUID guid_contextmenu_item_node_root_popup_matroska = 
{ 0xb4a87d2b, 0xfa1b, 0x450b, { 0x9a, 0xa4, 0xbb, 0xd1, 0x8c, 0xbf, 0x23, 0x93 } };

// {8D9A26C4-3809-40e8-A4D8-717C2A3BCAB6}
static const GUID guid_contextmenu_item_node_root_popup_matroska_list = 
{ 0x8d9a26c4, 0x3809, 0x40e8, { 0xa4, 0xd8, 0x71, 0x7c, 0x2a, 0x3b, 0xca, 0xb6 } };

// {703E27B6-0812-48ad-A895-F0B17170E33E}
static const GUID guid_contextmenu_item_node_leaf_matroska = 
{ 0x703e27b6, 0x812, 0x48ad, { 0xa8, 0x95, 0xf0, 0xb1, 0x71, 0x70, 0xe3, 0x3e } };

class contextmenu_item_matroska;
class contextmenu_item_node_root_popup_matroska_list;

class contextmenu_item_node_leaf_matroska : public contextmenu_item_node_root_leaf
{
private:
	enum MenuIndex {
		Open,
		SaveAs,
	};

	bool saveFile(const matroska::attachment & p_attachment, const pfc::string_base & p_path);

	contextmenu_item_node_root_popup_matroska_list* m_owner;
	t_size m_index;
	MenuIndex m_menuindex;
public:
	contextmenu_item_node_leaf_matroska(contextmenu_item_node_root_popup_matroska_list* p_owner, t_size p_index, t_size p_menuindex) : m_index(p_index)
	{
        m_owner = p_owner;
		m_menuindex = static_cast<MenuIndex>(p_menuindex);
	}
	
	bool get_display_data(pfc::string_base & p_out,unsigned & p_displayflags,const pfc::list_base_const_t<metadb_handle_ptr> & p_data,const GUID & p_caller)
	{
		switch (m_menuindex) {
		case Open:
			p_out = "Open";
			break;
		case SaveAs:
			p_out = "Save as...";
			break;
		}
		return true;
	}

	void execute(const pfc::list_base_const_t<metadb_handle_ptr> & p_data,const GUID & p_caller);

	bool get_description(pfc::string_base & p_out)
	{
		switch (m_menuindex) {
		case 0:
			p_out = "Opens in external application.";
			break;
		case 1:
			p_out = "Saves a selected attachment file in specified location.";
			break;
		}
		return true;
	}

	GUID get_guid()
	{
		return guid_contextmenu_item_node_leaf_matroska;
	}

	bool is_mappable_shortcut()
	{
		return false;
	}
};

class contextmenu_item_node_root_popup_matroska_list : public contextmenu_item_node_root_popup
{
private:
	service_ptr_t<contextmenu_item_matroska> m_owner;
	t_size m_index;
public:
	contextmenu_item_node_root_popup_matroska_list(service_ptr_t<contextmenu_item_matroska> p_owner, t_size p_index) : m_owner(p_owner), m_index(p_index) {}
	
	bool get_display_data(pfc::string_base & p_out,unsigned & p_displayflags,const pfc::list_base_const_t<metadb_handle_ptr> & p_data,const GUID & p_caller);

	t_size get_children_count()
	{
		return 2;
	}

	contextmenu_item_node * get_child(t_size p_index)
	{
		return new contextmenu_item_node_leaf_matroska(this, m_index, p_index);
	}

	GUID get_guid()
	{
		return guid_contextmenu_item_node_root_popup_matroska_list;
	}

	bool is_mappable_shortcut()
	{
		return false;
	}

	pfc::string8 getFileName(t_size p_index);
	service_ptr_t<contextmenu_item_matroska> getOwner()
	{
		return m_owner;
	}
};

class contextmenu_item_node_root_popup_matroska : public contextmenu_item_node_root_popup
{
private:
	service_ptr_t<contextmenu_item_matroska> m_owner;
public:
	contextmenu_item_node_root_popup_matroska(service_ptr_t<contextmenu_item_matroska> p_owner) : m_owner(p_owner) {}
	
	bool get_display_data(pfc::string_base & p_out,unsigned & p_displayflags,const pfc::list_base_const_t<metadb_handle_ptr> & p_data,const GUID & p_caller);

	t_size get_children_count();

	contextmenu_item_node * get_child(t_size p_index)
	{
		return new contextmenu_item_node_root_popup_matroska_list(m_owner, p_index);
	}

	GUID get_guid()
	{
		return guid_contextmenu_item_node_root_popup_matroska;
	}

	bool is_mappable_shortcut()
	{
		return false;
	}
};

class contextmenu_item_matroska : public contextmenu_item
{
private:
	pfc::string8 m_filepath;
    service_ptr_t<container_matroska> m_matroska;
public:
	~contextmenu_item_matroska()
	{
	}

	virtual unsigned get_num_items()
	{
		return 1;
	}

	virtual contextmenu_item_node_root * instantiate_item(unsigned p_index,const pfc::list_base_const_t<metadb_handle_ptr> & p_data,const GUID & p_caller)
	{
		if (p_caller != contextmenu_item::caller_now_playing &&
			p_caller != contextmenu_item::caller_playlist)
		{
			return NULL;
		}
		pfc::string8 path = p_data.get_item(0)->get_path();
		pfc::string8 ext = pfc::string_extension(path);
        try {
            container_matroska::g_open(m_matroska, path, true, m_abort);
            if (getAttachmentList()->get_count() > 0) {
			    m_filepath = path;
		        return new contextmenu_item_node_root_popup_matroska(this);
		    }
        } catch (const exception_io_data &) {
        }
		return NULL;
	}

	virtual GUID get_item_guid(unsigned p_index)
	{
		return guid_contextmenu_item_matroska;
	}

	virtual void get_item_name(unsigned p_index,pfc::string_base & p_out)
	{
		p_out = "Attachments";
	}

	virtual void get_item_default_path(unsigned p_index,pfc::string_base & p_out)
	{
		p_out = "Matroska Utils";
	}

	virtual bool get_item_description(unsigned p_index,pfc::string_base & p_out)
	{
		p_out = "Extracts attachments from Matroska files.";
		return true;
	}

	virtual t_enabled_state get_enabled_state(unsigned p_index)
	{
		return DEFAULT_ON;
	}

	virtual void item_execute_simple(unsigned p_index,const GUID & p_node,const pfc::list_base_const_t<metadb_handle_ptr> & p_data,const GUID & p_caller)
	{
	}

	pfc::string8 getFilePath()
	{
		return m_filepath;
	}

    const matroska::attachment_list * getAttachmentList()
	{
        return m_matroska->get_attachment_list();
	}

	abort_callback_impl m_abort;
};

static contextmenu_item_factory_t<contextmenu_item_matroska> g_contextmenu_item_matroska_factory;

#endif // _CONTEXTMENU_ITEM_MATROSKA_H_